<?php
/**
 * Luxeritas WordPress Theme - free/libre wordpress platform
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * @copyright Copyright (C) 2015 Thought is free.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GPL v2 or later
 * @author LunaNuko
 * @link https://thk.kanzae.net/
 * @translators rakeem( http://rakeem.jp/ )
 */

/*---------------------------------------------------------------------------
 * メディアボタン横
 *---------------------------------------------------------------------------*/
if( isset( $luxe['add_phrase_button_1'] ) ) {
	add_action( 'media_buttons', function() {
		$label = __( 'Fixed phrases', 'luxeritas' );
?>
<a href="#" id="thk-phrase-action" class="button" title="<?php echo $label; ?>"><span class="thk-phrase-icon"></span><?php echo $label; ?></a>
<?php
	}, 20 );
}

/*---------------------------------------------------------------------------
 * TinyMCE ボタン
 *---------------------------------------------------------------------------*/
if( isset( $luxe['add_phrase_button_2'] ) ) {
	if( get_user_option( 'rich_editing' ) === 'true' ) {
		add_filter( 'mce_external_plugins', function( $plugin_array ) {
			$plugin_array[ 'thk-phrase-button' ] = TDEL . '/js/' . 'thk-dummy.js';
			return $plugin_array;
		});
		add_filter( 'mce_buttons', function( $buttons ) {
			array_push( $buttons, 'thk-phrase-button' );
			return $buttons;
		});
	}
}

/*---------------------------------------------------------------------------
 * フッター（メイン処理）
 *---------------------------------------------------------------------------*/
add_action( 'admin_footer', function() {
	global $luxe;
?>
<!-- #dialog-form  -->
<div id="thk-phrase-form" title="<?php echo __( 'Insert fixed phrase', 'luxeritas' ); ?>">
	<form>
	<div class="radio-group">
<?php
$fp_mods = array();
$values  = array( 'close' => '' );
$admin_mods  = get_theme_phrase_mods();
$popup_nonce = wp_create_nonce( 'phrase_popup' );

foreach( (array)$admin_mods as $key => $val ) {
	if( strpos( $key, 'fp-' ) === 0 ) {
		$fp_mods[substr( $key, 3, strlen( $key ) )] = wp_parse_args( @json_decode( $val ), $values );
	}
}
unset( $admin_mods );

if( empty( $fp_mods ) ) {
?>
<p style="color:red"><?php echo __( 'There is no fixed phrases registered.', 'luxeritas' ); ?></p>
<?php
}
else {
	asort( $fp_mods );
	foreach( (array)$fp_mods as $key => $val ) {
		$fpid = strlen( $key ) . '-' . md5( $key );
?>
<input type="radio" id="<?php echo $fpid; ?>" name="fp_selector" value="<?php echo $key; ?>" data-phrase-sep="<?php echo $fpid; ?>" data-phrase-closing="<?php echo $val['close']; ?>" /><label for="<?php echo $fpid; ?>"><?php echo $key; ?></label>
<?php
	}
}
?>
	</div>
	</form>
<script>
jQuery(function($) {
	$('input[name=fp_selector]').change(function(){
	　　　　$('input[name=fp_selector][value='+$(this).val()+']').prop('checked', true);
	});
});
</script>
</div>

<div id="thk-phrase-form2" title="<?php echo __( 'Insert fixed phrase', 'luxeritas' ); ?>">
	<form>
		<div id="form-insert-phrase">
		<p id="fp-code-before"></p>
	        <textarea id="fp-code-text-before" name="code_text_before" rows="1" cols="1" style="display:none"></textarea>
	        <textarea id="fp-code-text" name="code_text" rows="8" cols="60"></textarea>
	        <textarea id="fp-code-text-after" name="code_text_after" rows="1" cols="1" style="display:none"></textarea>
		<p id="fp-code-after"></p>
		</div>
		<script>
		var fp_code_before_after = function( sep, code ) {
			var	before = document.getElementById("fp-code-before")
			,	after  = document.getElementById("fp-code-after")
			,	before_text = document.getElementById("fp-code-text-before")
			,	after_text  = document.getElementById("fp-code-text-after")
			,	strs = code.split( "\n<!--" + sep + "-->\n" )
			,	i = 0;

			strs.forEach( function( elem ) {
				strs[i] = elem.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;').replace(/"/g,'&quot;').replace(/'/g,"&apos;");
				++i;
			});

			before_text.innerHTML = strs[0];
			after_text.innerHTML = strs[1];
			before.innerHTML = '<span>' + strs[0] + '</span>';
			after.innerHTML = '<span>' + strs[1] + '</span>';
		}
		</script>
	</form>
</div>

<script>
jQuery(function($) {
	var bc    = '#option-'
	,   fpfm  = $('#thk-phrase-form')
	,   fpfm2 = $('#thk-phrase-form2');

	var thk_mce_insert = function( code, insert ) {
		if( code == '' || code == null ) return false;

		if( window.tinyMCE ) mce = tinyMCE;

		if( mce !== null && mce.activeEditor && !( mce.activeEditor.isHidden() ) ) {
			// TinyMCE がオープンならそれを使う
			tinyMCE.activeEditor.execCommand( 'mceInsertContent', false, insert )
		} else if(window.parent.QTags) {
			// なければ QTag で挿入
			QTags.insertContent( insert );
		}
	}

	fpfm.dialog({
		autoOpen: false,
		height: 'auto',
		width: 'auto',
		maxWidth: 640,
		minWidth: 300,
		modal: true,
		buttons: {  // ダイアログに表示するボタンと処理
			"<?php echo __( 'Insert', 'luxeritas' ); ?>": function() {
				var mce     = null
				,   insert  = null
				,   select  = $("input[name='fp_selector']:checked")
				,   code    = select.val()
				,   sep     = select.attr( 'data-phrase-sep' )
				,   closing = select.attr( 'data-phrase-closing' );

				if( closing == 1 ) {
					$(this).dialog('close');
					fpfm2.dialog('open');
					fpfm2.find('textarea#fp-code-text[name="code_text"]').val('');

					jQuery.ajax({
						type: 'POST',
						url: '<?php echo admin_url( "admin-ajax.php" ); ?>',
						data: {action:'thk_phrase_regist', name:code, fp_popup_nonce:'<?php echo $popup_nonce; ?>'},
						dataType: 'text',
						async: true,
						cache: false,
						timeout: 10000,
						success: function( response ) {
							fp_code_before_after( sep, response );
						},
						error: function() {
							fp_code_before_after( sep, '<?php echo __( "Failed to read.", "luxeritas" ); ?>' );
						}
					});
					return true;
				}

				jQuery.ajax({
					type: 'POST',
					url: '<?php echo admin_url( "admin-ajax.php" ); ?>',
					data: {action:'thk_phrase_regist', name:code, fp_popup_nonce:'<?php echo $popup_nonce; ?>'},
					dataType: 'text',
					async: true,
					cache: false,
					timeout: 10000,
					success: function( response ) {
						thk_mce_insert( code, response );
					},
					error: function() {
						thk_mce_insert( code, '<?php echo __( "Failed to read.", "luxeritas" ); ?>' );
					}
				});

				$(this).dialog('close');
				// ダイアログを閉じたらフォーカスを移す
				setTimeout( function(){ $('iframe').eq(0).focus(); }, 0 );
				setTimeout( function(){ $('textarea').eq(0).focus(); }, 0 );
			},
			"<?php echo __( 'Cancel', 'luxeritas' ); ?>": function() {
				$(this).dialog('close');
				// ダイアログを閉じたらフォーカスを移す
				setTimeout( function(){ $('iframe').eq(0).focus(); }, 0 );
				setTimeout( function(){ $('textarea').eq(0).focus(); }, 0 );
			}
		},
	});

<?php
if( isset( $luxe['add_phrase_button_2'] ) ) {
?>
	if( typeof QTags !== 'undefined' ) {
		var thk_phrase_dialog_open = function() {
			fpfm.dialog('open').dialog("open");
			fpfm.find('input').prop('checked', false);
		}
		QTags.addButton( 'thk-phrase', '<?php echo __( "Fixed phrases", "luxeritas" ); ?>', thk_phrase_dialog_open );
	}

	(function($) {
		if( typeof tinymce !== 'undefined' ) {
			tinymce.PluginManager.add( 'thk-phrase-button', function( editor, url ) {
				editor.addButton( "thk-phrase-button", {
					tooltip: "<?php echo __( 'Fixed phrases', 'luxeritas' ); ?>",
					onclick: function() {
						fpfm.dialog('open').dialog("open");
						fpfm.find('input').prop('checked', false);
					}
				});
			});
		}
	})(jQuery);
<?php
}
?>
	fpfm2.dialog({
		autoOpen: false,
		height: 'auto',
		width: 'auto',
		maxWidth: 666,
		modal: true,
		buttons: {  // ダイアログに表示するボタンと処理
			"<?php echo __( 'Insert', 'luxeritas' ); ?>": function() {
				var mce = null
				,   code = $("input[name='fp_selector']:checked").val()
				,   text = $("textarea#fp-code-text[name='code_text']").val()
				,   before_text = $("textarea#fp-code-text-before[name='code_text_before']").val()
				,   after_text  = $("textarea#fp-code-text-after[name='code_text_after']").val()
				,   insert = '';

				if( window.tinyMCE ) mce = tinyMCE;

				if( code == '' || code == null ) return false;

				if( mce !== null && mce.activeEditor && !( mce.activeEditor.isHidden() ) ) {
					// TinyMCE がオープンならそれを使う
					insert = before_text + text.replace( /\r?\n/g, "<br />\n" ) + after_text;
					tinyMCE.activeEditor.execCommand( 'mceInsertContent', false, insert )
				} else if(window.parent.QTags) {
					// なければ QTag で挿入
					insert = before_text + text + after_text;
					QTags.insertContent( insert );
				}
				$(this).dialog('close');
				// ダイアログを閉じたらフォーカスを移す
				setTimeout( function(){ $('iframe').eq(0).focus(); }, 0 );
				setTimeout( function(){ $('textarea').eq(0).focus(); }, 0 );
			},
			"<?php echo __( 'Cancel', 'luxeritas' ); ?>": function() {
				$(this).dialog('close');
				// ダイアログを閉じたらフォーカスを移す
				setTimeout( function(){ $('iframe').eq(0).focus(); }, 0 );
				setTimeout( function(){ $('textarea').eq(0).focus(); }, 0 );
			}
		},
	});

	// 定型文ボタンがクリックされたらダイアログを表示
	$('#thk-phrase-action').click( function() {
		fpfm.dialog('open');
		fpfm.find('input').prop('checked', false);

		// ボタンの色を WordPress の管理画面の配色に合わせた色に変更する
		if( typeof $('body .button-primary')[0] !== 'undefined' ) {
	        	var bp = $('body .button-primary, body .ui-button-icon')
			,   ub = $('body .ui-button')
	        	,   csspa = {
				'background': bp.css('background'),
				'box-shadow': bp.css('box-shadow'),
				'border-color': bp.css('border-color')
			};
			$.each( csspa, function( i, elm ) {
				ub.css( i, elm );
			});
			ub.hover(
				function() {
					$(this).css('opacity', '.85');
				},
				function() {
					$(this).css('opacity', '');
				}
			);
		}
		return false;
	});

	// オーバーレイがクリックされたらダイアログを閉じる
	$(document).on( 'click', '.ui-widget-overlay', function() {
		fpfm.dialog('close');
		fpfm2.dialog('close');
		setTimeout( function(){ $('iframe').eq(0).focus(); }, 0 );
		setTimeout( function(){ $('textarea').eq(0).focus(); }, 0 );
	}); 
});

// タブの入力ができるようにする
var textareas = document.getElementsByTagName('textarea');
var count = textareas.length;
for( var i = 0; i < count; i++ ) {
	textareas[i].onkeydown = function(e){
		if( e.keyCode === 9 || e.which === 9 ) {
			e.preventDefault();
			var s = this.selectionStart;
			this.value = this.value.substring( 0, this.selectionStart ) + "\t" + this.value.substring( this.selectionEnd );
			this.selectionEnd = s + 1;
		}
	}
}
</script>
<?php
});
